--- old/usr/src/uts/common/io/fibre-channel/ulp/fcp.c	Thu Aug 16 02:34:30 2018
+++ new/usr/src/uts/common/io/fibre-channel/ulp/fcp.c	Thu Aug 16 02:34:30 2018
@@ -8213,13 +8213,11 @@
 
 	if (online == FCP_ONLINE) {
 		ccip = fcp_get_cip(plun, cip, lcount, tcount);
-		if (ccip == NULL) {
-			goto fail;
-		}
+		if (ccip == NULL)
+			goto skip;
 	} else {
-		if (fcp_is_child_present(plun, cip) != FC_SUCCESS) {
-			goto fail;
-		}
+		if (fcp_is_child_present(plun, cip) != FC_SUCCESS)
+			goto skip;
 		ccip = cip;
 	}
 
@@ -8226,18 +8224,21 @@
 	if (online == FCP_ONLINE) {
 		rval = fcp_online_child(plun, ccip, lcount, tcount, flags,
 		    &circ);
-		fc_ulp_log_device_event(pptr->port_fp_handle,
-		    FC_ULP_DEVICE_ONLINE);
 	} else {
 		rval = fcp_offline_child(plun, ccip, lcount, tcount, flags,
 		    &circ);
-		fc_ulp_log_device_event(pptr->port_fp_handle,
-		    FC_ULP_DEVICE_OFFLINE);
 	}
 
-fail:	mutex_exit(&plun->lun_mutex);
+skip:
+	mutex_exit(&plun->lun_mutex);
 	mutex_exit(&pptr->port_mutex);
 
+	if (rval == NDI_SUCCESS) {
+		fc_ulp_log_device_event(pptr->port_fp_handle,
+		    online == FCP_ONLINE ?
+		    FC_ULP_DEVICE_ONLINE : FC_ULP_DEVICE_OFFLINE);
+	}
+
 	if (is_mpxio) {
 		mdi_devi_exit(pptr->port_dip, circ);
 	} else {
@@ -11044,28 +11045,19 @@
 	    "fcp_transport Invoked for %x", plun->lun_tgt->tgt_d_id);
 
 	/*
-	 * It is strange that we enter the fcp_port mutex and the target
-	 * mutex to check the lun state (which has a mutex of its own).
-	 */
-	mutex_enter(&pptr->port_mutex);
-	mutex_enter(&ptgt->tgt_mutex);
-
-	/*
 	 * If the device is offline and is not in the process of coming
 	 * online, fail the request.
 	 */
-
+	mutex_enter(&plun->lun_mutex);
 	if ((plun->lun_state & FCP_LUN_OFFLINE) &&
 	    !(plun->lun_state & FCP_LUN_ONLINING)) {
-		mutex_exit(&ptgt->tgt_mutex);
-		mutex_exit(&pptr->port_mutex);
-
-		if (cmd->cmd_fp_pkt->pkt_pd == NULL) {
+		mutex_exit(&plun->lun_mutex);
+		if (cmd->cmd_fp_pkt->pkt_pd == NULL)
 			pkt->pkt_reason = CMD_DEV_GONE;
-		}
-
 		return (TRAN_FATAL_ERROR);
 	}
+	mutex_exit(&plun->lun_mutex);
+
 	cmd->cmd_fp_pkt->pkt_timeout = pkt->pkt_time;
 
 	/*
@@ -11090,6 +11082,9 @@
 	 * packet initialization.
 	 */
 
+	mutex_enter(&pptr->port_mutex);
+	mutex_enter(&ptgt->tgt_mutex);
+
 	if (((plun->lun_state & FCP_LUN_BUSY) && (!(pptr->port_state &
 	    FCP_STATE_SUSPENDED)) && !ddi_in_panic()) ||
 	    (pptr->port_state & (FCP_STATE_ONLINING | FCP_STATE_IN_CB_DEVC)) ||
